
function width(o) { return o.offsetWidth||o.clientWidth; }

function getTextWidth(text, font) {
  // re-use canvas object for better performance
  const canvas = getTextWidth.canvas || (getTextWidth.canvas = document.createElement("canvas"));
  const context = canvas.getContext("2d");
  context.font = font;
  const metrics = context.measureText(text);
  return metrics.width;
}

function getCssStyle(element, prop) {
    return window.getComputedStyle(element, null).getPropertyValue(prop);
}

function getCanvasFontSize(el = document.body) {
  const fontWeight = getCssStyle(el, 'font-weight') || 'normal';
  const fontSize = getCssStyle(el, 'font-size') || '16px';
  const fontFamily = getCssStyle(el, 'font-family') || 'Times New Roman';
  
  return `${fontWeight} ${fontSize} ${fontFamily}`;
}

function clientRect(o) {
  var cr = {  x: 0, y: 0, w: o.offsetWidth||o.clientWidth , h: o.offsetHeight||o.clientHeight }
  while(o!=null) {
    cr.x +=  o.offsetLeft || 0;  // mozilla: .client*
    cr.y +=  o.offsetTop || 0;
    o = o.offsetParent; // mozilla: parentNode
  }
  return cr;
}



function ShowPopUp(id,at) {
  var popup = document.getElementById(id)
  popup.style.position = 'absolute';
  popup.style.display = 'block';
  var cr = clientRect(at), popup_width = popup.scrollWidth || popup.offsetWidth || popup.clientWidth; 
  popup.style.left = cr.x + cr.w * 2  - popup_width + 'px' //at.style.right || 
  popup.style.top =  cr.y + 'px'; //at.style.top || mouseY(at);
  popup.style.visibility = 'visible';
  document.onmousemove = CheckHidePopUp
  window.clearTimeout(popup.timeout);
}

function CheckHidePopUp(ev) {
  var id='PopUpMenu';
  var popup = document.getElementById(id)
  window.clearTimeout(popup.timeout);
  if(!mousein(ev,popup)) {
    popup.timeout = window.setTimeout('HidePopUp("'+id+'")',300);
  }
} 

function HidePopUp(id) {
  var popup = document.getElementById(id)
  popup.style.display = 'none';
  popup.style.visibility = 'hidden';
  popup.timeout = 0;
  document.onmousemove = null;
}


var ubers = null;  // filled with h4-tags
var inhvz = "<ul>", link, prevlinktg, linktg="", nextlinktg="", ll;
var popup = "<ul>", heading="";
var lang_up = "up", lang_down = "down", lang_directory = "Directory", lang_menu = "Menu";

function inserNavLinks(i) {
  var lntab = document.createElement("div"); lntab.style.position='relative';
  lntab.setAttribute("class","popupnav");
  ubers[i].parentNode.insertBefore(lntab,ubers[i]); //ubers[i].appendChild(lntab)
  ll = "<div class=h3menu style='position: absolute; top: -1.1em; right:6em;'>"
  if(prevlinktg) ll += "<a href='#"+ prevlinktg +"'>"+lang_up+"</a> "; else ll += "<font>"+lang_up+"</font>";
  if(nextlinktg) ll += "<a href='#"+ nextlinktg +"'>"+lang_down+"</a> "; else ll += "<font>"+lang_down+"</font>";
  ll += "<a href=#top>"+lang_directory+"</a>"
  ll += "<a onclick=\"ShowPopUp('PopUpMenu',this)\">"+lang_menu+"</a>"
  //alert(ll);
  lntab.innerHTML = ll + "</div>"
  return lntab;
}


function prepareMenus(lang,headings) {
  if(lang=="de") { lang_up="rauf"; lang_down = "runter"; lang_directory = "Inhalt"; lang_menu = "Menü"; }
  if(headings!=null) ubers = headings;
  else ubers = document.getElementsByTagName("h4");
  //var body_width = width(document.body);
  for(i=0; i<ubers.length; i++) {
    prevlinktg = linktg; linktg = nextlinktg; 
    if( ubers[i].parentNode.nodeName=="DIV" || ubers[i].parentNode.nodeName=="SECTION" ) heading = ubers[i].parentNode
    else if( ubers[i].parentNode.parentNode && ( ubers[i].parentNode.parentNode.nodeName=="DIV" ||
	                                         ubers[i].parentNode.parentNode.nodeName=="SECTION" ) ) heading = ubers[i].parentNode.parentNode;    // hX inside hgroup
    else if( ubers[i].parentNode.parentNode && ubers[i].parentNode.parentNode.parentNode && 
	     ( ubers[i].parentNode.parentNode.parentNode.nodeName=="DIV" ||
	       ubers[i].parentNode.parentNode.parentNode.nodeName=="SECTION" ) ) heading = ubers[i].parentNode.parentNode.parentNode;   // hX inside header & hgroup
    else if(ubers[i].previousSibling.nodeName=="DIV") heading = ubers[i].previousSibling;  // double-headers without hgroup not allowed in HTML5: do not check for <section>
    if(heading) {
      nextlinktg = heading.getAttribute("id")
      link = "<a href=#"+nextlinktg+"> " + TextOf(ubers[i]) + "</a>"
      inhvz += "<li> " + link
      popup += "<li> " + link
    } else inhvz += "<li>" + TextOf(ubers[i]);
    //if(ubers[i].parentNode.=="A")
    if( ubers[i].nextSibling && ubers[i].nextSibling.nodeName.substr(0,1)=="H" )
      inhvz += " (" + TextOf(ubers[i].nextSibling) + ")";
    else inhvz += "";
    inhvz+="</li>"
    if(i>0) {
      lntab = inserNavLinks(i-1);
      var ubers_size = getTextWidth(ubers[i].innerText+'xx', getCanvasFontSize(ubers[i]));
      //if(i==6) alert(ubers[i].innerText+'/'+clientRect(ubers[i]).x+'+'+ubers_size+'>='+clientRect(lntab.firstChild).x);
      //var anchorText = document.createTextNode("»"+clientRect(ubers[i]).x+'+'+ubers_size+'>='+clientRect(lntab.firstChild).x);
      //lntab.insertBefore(anchorText,lntab.firstChild);
      if( clientRect(ubers[i]).x + ubers_size >= clientRect(lntab.firstChild).x ) {
	//var anchorText = document.createElement("br");
	var anchorText = document.createTextNode("»");
	lntab.insertBefore(anchorText,lntab.firstChild);
	lntab.style.marginTop="2ex";
    } }
  }
  prevlinktg = linktg; linktg = nextlinktg; nextlinktg=""; 
  inserNavLinks(ubers.length-1);
  inhvz += "</ul>"
  popup += "</ul>"
  var contentmenu = document.getElementById("Inhaltsverzeichnis") || document.Inhaltsverzeichnis;
  if(contentmenu) contentmenu.innerHTML = inhvz;
  var popupmenu = document.getElementById("PopUpMenu") || document.PopUpMenu;
  if(popupmenu) popupmenu.innerHTML = popup;
}

